import Mock from 'mockjs'
import { param2Obj } from '@/utils'

import example from './example'

const mocks: any[] = [
  ...example
]

// for front mock
// please use it cautiously, it will redefine XMLHttpRequest,
// which will cause many of your third-party libraries to be invalidated(like progress event).
export function mockXHR() {
  const send: any = (Mock as any).XHR.prototype.send;
  ((Mock as any).XHR.prototype as any).proxy_send = send;
  (Mock as any).XHR.prototype.send = function() {
    if (this.custom.xhr) {
      this.custom.xhr.withCredentials = this.withCredentials || false

      if (this.responseType) {
        this.custom.xhr.responseType = this.responseType
      }
    }
    /* eslint-disable */
    this.proxy_send(...arguments)
  }

  function XHR2ExpressReqWrap(respond: any) {
    return function(options: any) {
      let result = null
      if (respond instanceof Function) {
        const { body, type, url } = options
        // https://expressjs.com/en/4x/api.html#req
        result = respond({
          method: type,
          body: JSON.parse(body),
          query: param2Obj(url)
        })
      } else {
        result = respond
      }
      return Mock.mock(result)
    }
  }

  for (const i of mocks) {
    Mock.mock(new RegExp(i.url), i.type || 'get', XHR2ExpressReqWrap(i.response))
  }
}

// for mock server
const responseFake = (url: string, type: string, respond: any) => {
  return {
    url: new RegExp(`${url}`),
    type: type || 'get',
    response(req: any, res: any) {
      res.json(Mock.mock(respond instanceof Function ? respond(req, res) : respond))
    }
  }
}

export default mocks.map(route => {
  return responseFake(route.url, route.type, route.response)
})
